using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;
using Syncfusion.Styles;


namespace Grid_MultiSelect
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.InitializeGrid();                     
            this.LoadData();
        }

        private void InitializeGrid()
        {                         
            this.TheGrid.AllowDragSelectedCols = true;
            this.TheGrid.ColCount = 1;
            this.TheGrid.ColWidthEntries.AddRange( new Syncfusion.Windows.Forms.Grid.GridColWidth[] {
            new Syncfusion.Windows.Forms.Grid.GridColWidth(0, 35)} );
            this.TheGrid.ControllerOptions = ((Syncfusion.Windows.Forms.Grid.GridControllerOptions)((((Syncfusion.Windows.Forms.Grid.GridControllerOptions.ClickCells
                        | Syncfusion.Windows.Forms.Grid.GridControllerOptions.SelectCells)
                        | Syncfusion.Windows.Forms.Grid.GridControllerOptions.ResizeCells)
                        | Syncfusion.Windows.Forms.Grid.GridControllerOptions.DragColumnHeader)
                        | Syncfusion.Windows.Forms.Grid.GridControllerOptions.ExcelLikeSelection));
            this.TheGrid.DefaultRowHeight = 16;
            this.TheGrid.Dock = System.Windows.Forms.DockStyle.Fill;
            this.TheGrid.Font = new System.Drawing.Font( "Arial", 8F );
            this.TheGrid.ForeColor = System.Drawing.SystemColors.ControlText;
            this.TheGrid.Name = "TheGrid";
            this.TheGrid.NumberedColHeaders = false;
            this.TheGrid.NumberedRowHeaders = false;
            this.TheGrid.Properties.BackgroundColorString = "Control";
            this.TheGrid.Properties.FixedLinesColorString = "ActiveCaption";
            this.TheGrid.Properties.GridLineColorString = "GrayText";
            this.TheGrid.Properties.ResizingCellsLinesColorString = "Red";
            this.TheGrid.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.TheGrid.RowCount = 1;
            this.TheGrid.RowHeightEntries.AddRange( new Syncfusion.Windows.Forms.Grid.GridRowHeight[] {
            new Syncfusion.Windows.Forms.Grid.GridRowHeight(0, 16)} );
            this.TheGrid.SelectCellsMouseButtonsMask = ((System.Windows.Forms.MouseButtons)((System.Windows.Forms.MouseButtons.Left | System.Windows.Forms.MouseButtons.Middle)));
            this.TheGrid.SmartSizeBox = false;
            this.TheGrid.UseWaitCursor = true;

            this.TheGrid.Model.Options.DisplayEmptyRows = true;
            this.TheGrid.Model.Options.DisplayEmptyColumns = true;

            //AFFECTS KEYBOARD NAVIGATION!!!!!!!
            this.TheGrid.Properties.RowHeaders = false;
        }

        void Form1_Load( object sender, System.EventArgs e )
        {
            this.TheGrid.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler( this.TheGrid_PrepareViewStyleInfo );
        }

       

        private void LoadData()
        {
           
            this.TheGrid.ColCount = 0;
            this.TheGrid.SetColWidth(0, 0,20 );
            this.TheGrid.SetColWidth( 1, 1, 20 );
            this.TheGrid.ColCount = 10;
            this.SetColHeaderText();
            this.TheGrid.RowCount = 10;

            for (int i = 1; i <= 10; i++)
            {
                if (i == 1)
                {
                    this.AddHeaderRow( i );
                }
                else
                {


                    for (int j = 1; j <= TheGrid.ColCount; j++)
                    {
                        //if (j == 1)
                        //{
                        //    this.AddCheckBox( i, j );
                        //}
                        //else if (j == 5)
                        //{
                        //    this.AddTextBox( i, j );
                        //}
                        //else
                        //{
                            this.AddCell( i, j );
                        //}
                    }
                }
            }

            this.TheGrid.Model.RowHeights.ResizeToFit( GridRangeInfo.Cols( 0,this.TheGrid.ColCount ), GridResizeToFitOptions.None );
           
        }

        private void AddHeaderRow( int rowIndex )
        {
            GridRangeInfo oRange = null;
            GridStyleInfo style = new GridStyleInfo();

            oRange = GridRangeInfo.Cells( rowIndex, 1, rowIndex, this.TheGrid.ColCount );
            this.TheGrid.CoveredRanges.Add( oRange );

            style.CellType = "Static";
            style.CellValue = "Section Header";
            style.Font.Size = 8;
            style.Interior = new BrushInfo( GradientStyle.Vertical, Color.FromArgb( 187, 194, 214 ), Color.White );
            style.VerticalAlignment = GridVerticalAlignment.Middle;
            style.HorizontalAlignment = GridHorizontalAlignment.Left;

            this.TheGrid.Data[rowIndex, 1] = style.Store;
        }

        private void AddCell( int row, int col )
        {
            this.TheGrid[row, col].Trimming = StringTrimming.EllipsisWord;
            this.TheGrid[row, col].CellType = "Static";
            if (col == 10)
            {
                if (row == 2)
                {
                    this.TheGrid[row, col].Text = "Wrap Me: Testing, testing, 123 Testing, testing, 123 Testing, testing, 123 Testing, testing, 123";
                    this.TheGrid[row, col].WrapText = true;
                }
                else
                {
                    this.TheGrid[row, col].Text = "Wrap Me: Testing, testing, 123";
                    this.TheGrid[row, col].WrapText = true;
                }
            }
            else
            {
                this.TheGrid[row, col].Text = "Testing, testing, 123";
                this.TheGrid[row, col].WrapText = false;
            }

            this.TheGrid[row, col].ReadOnly = true;

        }

        private void AddCheckBox( int row, int col )
        {
            this.TheGrid[row, col].CellType = "CheckBox";
            //this.TheGrid[row, col].CellValue = 1;
            this.TheGrid[row, col].HorizontalAlignment = GridHorizontalAlignment.Center;
            this.TheGrid[row, col].ReadOnly = true;

        }

        private void AddTextBox( int row, int col )
        {
            this.TheGrid[row, col].CellType = "TextBox";
            this.TheGrid[row, col].MaxLength = 255;
         }

        private void SetColHeaderText()
        {
            for (int i = 2; i <= this.TheGrid.ColCount; i++)
            {
                this.TheGrid[0, i].Text = string.Concat( "Column", (i - 1).ToString() );
            }

        }       

        private void SetEmptyRows( int iStart )
        {
            for (int i = iStart; i <= this.TheGrid.RowCount; i++)
            {
                this.TheGrid[i, 0].ImageIndex = 4;
                this.TheGrid[i, 0].Tag = "EMPTY";
                //this.TheGrid[i, 0].BaseStyle = "Header";
                                
            }
        }

        void TheGrid_MouseDown( object sender, System.Windows.Forms.MouseEventArgs e )
        {

            if (e.Button == MouseButtons.Right)
            {
                if (!this.TheGrid.Selections.GetSelectedRows( true, false ).ActiveRange.IsTable)
                {
                    //if (this.ShowContextMenu)
                    //{
                    GridCurrentCell cc = this.TheGrid.CurrentCell;
                    Point pt = new Point( e.X, e.Y );

                    this.gridContextMenu.Show( this.TheGrid, pt );
                    //}
                }
            }
        }

        void TheGrid_RowsInserted( object sender, Syncfusion.Windows.Forms.Grid.GridRangeInsertedEventArgs e )
        {
            //if (this.TheGrid.RowCount > 10)
            //{
            //    this.SetEmptyRows( e.InsertAt );
            //}

            //int iRowCount = e.Count;
            //int iGridRowcount = this.TheGrid.RowCount;
            //int iRow = e.InsertAt;

        }

        void TheGrid_SelectionChanging( object sender, Syncfusion.Windows.Forms.Grid.GridSelectionChangingEventArgs e )
        {
            if (e.Range.ExpandRange( 1, 1, this.TheGrid.RowCount, this.TheGrid.ColCount ).Bottom 
                > this.TheGrid.RowCount)
            {
                e.Cancel = true;
            }

        }

        void TheGrid_ClipboardCanCopy( object sender, Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs e )
        {
            //allow single cell paste
            e.IgnoreCurrentCell = false;
            e.Result = true;
            e.Handled = true;

        }

        void TheGrid_CellClick( object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e )
        {
            if (e.ColIndex > 1 && e.MouseEventArgs.Button != MouseButtons.Right)
            {
                this.ClearSelections();
            }
        }

        void mnuRemoveSelection_Click( object sender, System.EventArgs e )
        {
            this.RemoveRows();
        }

        protected override bool ProcessCmdKey( ref Message msg, Keys keyData )
        {
            bool bProcessed = false;
            const int WM_KEYDOWN = 0x100;
            const int WM_SYSKEYDOWN = 0x104;

            if ((msg.Msg == WM_KEYDOWN) || (msg.Msg == WM_SYSKEYDOWN))
            {
                switch (keyData)
                {
                    case Keys.Escape:
                        if (!this.gridContextMenu.Visible)
                        {
                            this.ClearSelections();
                        }
                        break;
                    case Keys.Control | Keys.M:
                        this.RemoveRows();
                    break;
                }
            }
            if (!bProcessed)
            {
                bProcessed = base.ProcessCmdKey( ref msg, keyData );
            }

            return bProcessed;
        }

        private void ClearSelections()
        {
            this.TheGrid.Model.Selections.Clear();
        }

        private void RemoveRows()
        {                     
            GridRangeInfoList oRows = this.TheGrid.Selections.GetSelectedRows( false, true );
            
            foreach (GridRangeInfo range in oRows)
            {
                GridRangeInfo range1 = range.ExpandRange( 1, 1, this.TheGrid.RowCount, this.TheGrid.ColCount );
                //message box to be replaced with call to remove rows
                System.Windows.Forms.MessageBox.Show( string.Concat("Remove selected rows ", range1.Top.ToString(), " to ", range1.Bottom.ToString() ));
            }
            this.ClearSelections();
        }

        //int totalRowCount = -1;
        private void TheGrid_PrepareViewStyleInfo( object sender, GridPrepareViewStyleInfoEventArgs e )
        {
            if (e.RowIndex > this.TheGrid.RowCount)
            {
                e.Style.Enabled = false;
                if (e.ColIndex == 0)
                {
                    //set to empty image
                    e.Style.ImageIndex = 4;                    
                }
            } 
        }

    }
}